//+------------------------------------------------------------------+
//|                                                  ZigZagGM_v3.mq4 |
//|                                                        GrayMan77 |
//|                                                                  |
//|  v3 -   (  PriceChannel  ). |
//|  |
//|  |
//+------------------------------------------------------------------+
#property copyright "GrayMan77"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Coral
#property indicator_color2 SkyBlue

//---- input parameters
extern int       ExtDepth=12;

//---- buffers
double BufferHigh[];
double BufferLow[];
double PriceChannelHigh[];
double PriceChannelLow[];

//---- var
int ShiftHigh,ShiftLow;
double PriceHigh,PriceLow;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(4);
   
   SetIndexBuffer(0,BufferHigh);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,110);
   
   SetIndexBuffer(1,BufferLow);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,110);
   
   SetIndexBuffer(2,PriceChannelHigh);
   SetIndexBuffer(3,PriceChannelLow);
   
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);
   SetIndexEmptyValue(3,0.0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  int    counted_bars=IndicatorCounted();
  int i,j,limit;
  //int ShiftHigh,ShiftLow;
  int ShiftBufferHigh,ShiftBufferLow;
  double deltaHigh, deltaLow;
//----
  
  //  
  if(counted_bars<0) return(-1);
  
  //    
  if(counted_bars==0)  //     (  )
    {
    limit=Bars-ExtDepth;
    FindLevelPriceChannel(limit);
    //    
    BufferHigh[ShiftHigh]=PriceHigh;
    BufferLow[ShiftLow]=PriceLow;
    PriceChannelHigh[limit]=PriceHigh;
    PriceChannelLow[limit]=PriceLow;
    limit--;
    
    }
   else
    {
    counted_bars--;  //    
    limit = Bars - counted_bars;
    if(limit>Bars-ExtDepth-1) limit=Bars-ExtDepth-1;
    }
  
  for(i=limit; i>=0; i--) //   
    {
    FindLevelPriceChannel(i);
    //   PriceChannel
    PriceChannelHigh[i]=PriceHigh;
    PriceChannelLow[i]=PriceLow;
    /*
    //   BufferHigh[],BufferLow[]   
    BufferHigh[i]=0.;
    BufferLow[i]=0.;
    */
    //      BufferHigh[],BufferLow[]
    j=i+1;
    ShiftBufferHigh=0;
    ShiftBufferLow=0;
    while(ShiftBufferHigh==0 && ShiftBufferLow==0 && j<Bars)
      {
      if(BufferHigh[j]!=0.) ShiftBufferHigh=j;
      if(BufferLow[j]!=0.) ShiftBufferLow=j;
      j++;
      }
    
    //   BufferHigh[],BufferLow[]:
    
    // -    
    if(PriceChannelLow[i]<PriceChannelLow[i+1] && PriceChannelHigh[i]<=PriceChannelHigh[i+1])
      {
      if(ShiftBufferHigh!=0)  //     - 
        {
        //   
        BufferLow[i]=PriceChannelLow[i];
        }
      if(ShiftBufferLow!=0)  //     - 
        {
        //    (    )
        if(BufferLow[ShiftBufferLow]>PriceChannelLow[i])
          {
          BufferLow[ShiftBufferLow]=0.;  //  
          BufferLow[i]=PriceChannelLow[i];  //  
          }
        }
      }
    
    // -    
    if(PriceChannelHigh[i]>PriceChannelHigh[i+1] && PriceChannelLow[i]>=PriceChannelLow[i+1])
      {
      if(ShiftBufferLow!=0)  //     - 
        {
        //   
        BufferHigh[i]=PriceChannelHigh[i];
        }
      if(ShiftBufferHigh!=0)  //     - 
        {
        //    (    )
        if(BufferHigh[ShiftBufferHigh]<PriceChannelHigh[i])
          {
          BufferHigh[ShiftBufferHigh]=0.;  //  
          BufferHigh[i]=PriceChannelHigh[i];  //  
          }
        }
      }
    
    // -      
    if(PriceChannelLow[i]<PriceChannelLow[i+1] && PriceChannelHigh[i]>PriceChannelHigh[i+1])
      {
      //      
      deltaHigh=PriceChannelHigh[i]-PriceChannelHigh[i+1];
      deltaLow=PriceChannelLow[i+1]-PriceChannelLow[i];
      //    
      if(deltaHigh>deltaLow)
        {
        if(ShiftBufferLow!=0)  //     - 
          {
          //   
          BufferHigh[i]=PriceChannelHigh[i];
          }
        if(ShiftBufferHigh!=0)  //     - 
          {
          //    (    )
          if(BufferHigh[ShiftBufferHigh]<PriceChannelHigh[i])
            {
            BufferHigh[ShiftBufferHigh]=0.;  //  
            BufferHigh[i]=PriceChannelHigh[i];  //  
            }
          } 
        }
       else   //     ( !!!)
        {
        if(ShiftBufferHigh!=0)  //     - 
          {
          //   
          BufferLow[i]=PriceChannelLow[i];
          }
        if(ShiftBufferLow!=0)  //     - 
          {
          //    (    )
          if(BufferLow[ShiftBufferLow]>PriceChannelLow[i])
            {
            BufferLow[ShiftBufferLow]=0.;  //  
            BufferLow[i]=PriceChannelLow[i];  //  
            }
          }
        }
      
      }
      
    }
  
  
   
//----
  return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|    PriceHigh,PriceLow  PriceChannel,  |
//|    ExtDepth,   ,|
//|      ShiftHigh,ShiftLow.         |
//+------------------------------------------------------------------+
void FindLevelPriceChannel(int Shift)
  {
  int i;
  int sum=Shift+ExtDepth;
  int s1=Shift+1;
  //int ShHi,ShLo;
  
  PriceHigh=High[Shift];
  PriceLow=Low[Shift];
  ShiftHigh=Shift;
  ShiftLow=Shift;
  for(i=s1;i<sum;i++)
    {
    if(High[i]>PriceHigh)
      {
      PriceHigh=High[i];
      ShiftHigh=i;
      }
    if(Low[i]<PriceLow)
      {
      PriceLow=Low[i];
      ShiftLow=i;
      }
    }
  
  return;
  }
//+------------------------------------------------------------------+

